Index: TWiki/Store.pm
===================================================================
--- TWiki/Store.pm	(revision 13172)
+++ TWiki/Store.pm	(working copy)
@@ -69,13 +69,9 @@
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
-    ASSERT($session->isa('TWiki')) if DEBUG;
-
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
 
-    $this->{session} = $session;
-
     $this->{IMPL} = 'TWiki::Store::'.$TWiki::cfg{StoreImpl};
     eval 'use '.$this->{IMPL};
     if( $@ ) {
@@ -107,7 +103,7 @@
 sub _getHandler {
     my( $this, $web, $topic, $attachment ) = @_;
 
-    return $this->{IMPL}->new( $this->{session}, $web, $topic, $attachment );
+    return $this->{IMPL}->new( $web, $topic, $attachment );
 }
 
 =pod
@@ -141,16 +137,17 @@
     }
 
     my $text = $this->readTopicRaw( $user, $web, $topic, $version );
-    my $meta = new TWiki::Meta( $this->{session}, $web, $topic);
+    my $meta = new TWiki::Meta( $web, $topic);
     $this->extractMetaData( $meta, \$text );
 
     # Override meta with that blended from pub.
     if ($TWiki::cfg{AutoAttachPubFiles} &&
-        $web eq $this->{session}{webName} && # only check the currently requested topic
-        $topic eq $this->{session}{topicName}) {
+        $web eq $TWiki::SESSION->{webName} && # only check the currently requested topic
+        $topic eq $TWiki::SESSION->{topicName}) {
 
       my @knownAttachments = $meta->find('FILEATTACHMENT');
-      my @attachmentsFoundInPub = _findAttachments($this, $web, $topic, \@knownAttachments);
+      my @attachmentsFoundInPub = $this->_findAttachments(
+          $web, $topic, \@knownAttachments);
       $meta->putAll('FILEATTACHMENT', @attachmentsFoundInPub) if @attachmentsFoundInPub;
     }
 
@@ -159,7 +156,7 @@
 
 =pod 
 
----++ ObjectMethod _findAttachments($session, $web, $topic, $knownAttachments) -> @attachmentsFoundInPub
+---++ ObjectMethod _findAttachments($web, $topic, $knownAttachments) -> @attachmentsFoundInPub
 
 Synchronise the attachment list with what's actually on disk Returns an ARRAY
 of FILEATTACHMENTs. These can be put in the new meta using
@@ -176,12 +173,8 @@
 
 sub _findAttachments {
     my ($this, $web, $topic, $attachmentsKnownInMeta) = @_;
-    my $session = $this->{session};
-    ASSERT($session->isa( 'TWiki' )) if DEBUG;
 
-    my $store = $this;
-
-    my %filesListedInPub = $store->getAttachmentList($web, $topic);
+    my %filesListedInPub = $this->getAttachmentList($web, $topic);
     my %filesListedInMeta = ();
 
     # You need the following lines if you want metadata to supplement
@@ -253,7 +246,7 @@
 
     # test if topic contains a webName to override $web
     ( $web, $topic ) =
-      $this->{session}->normalizeWebTopicName( $web, $topic );
+      $TWiki::SESSION->normalizeWebTopicName( $web, $topic );
 
     my $text;
 
@@ -267,11 +260,11 @@
     # Note: passing undef as meta will cause extraction of the meta
     # from the (raw) text passed
     if( $user &&
-          !$this->{session}->{security}->checkAccessPermission
+          !$TWiki::ACCESS->checkAccessPermission
             ( 'VIEW', $user, $text, undef, $topic, $web )) {
         throw TWiki::AccessControlException(
             'VIEW', $user, $web, $topic,
-            $this->{session}->{security}->getReason());
+            $TWiki::ACCESS->getReason());
     }
 
     return $text;
@@ -299,20 +292,20 @@
     try {
         my( $ometa, $otext ) = $this->readTopic( undef, $oldWeb, $oldTopic );
         if( $user &&
-              !$this->{session}->{security}->checkAccessPermission
+              !$TWiki::ACCESS->checkAccessPermission
                 ( 'CHANGE', $user, $otext, $ometa, $oldTopic, $oldWeb )) {
             throw TWiki::AccessControlException(
                 'CHANGE', $user, $oldWeb, $oldTopic,
-                $this->{session}->{security}->getReason());
+                $TWiki::ACCESS->getReason());
         }
 
         my ( $nmeta, $ntext ) = $this->readTopic( undef, $newWeb, $newTopic );
         if( $user &&
-              !$this->{session}->{security}->checkAccessPermission
+              !$TWiki::ACCESS->checkAccessPermission
                 ( 'CHANGE', $user, $ntext, $nmeta, $newTopic, $newWeb )) {
             throw TWiki::AccessControlException(
                 'CHANGE', $user, $newWeb, $newTopic,
-                $this->{session}->{security}->getReason());
+                $TWiki::ACCESS->getReason());
         }
 
         # Remove file attachment from old topic
@@ -339,7 +332,7 @@
                                 $nmeta, { dontlog => 1,
                                           notify => 0,
                                           comment => 'moved' } );
-        $this->{session}->writeLog(
+        $TWiki::SESSION->writeLog(
             'move',
             $fileAttachment->{movefrom}.' moved to '.
               $fileAttachment->{movedto}, $user->webDotWikiName() );
@@ -349,7 +342,7 @@
     };
 
     # alert plugins of attachment move
-    $this->{session}->{plugins}->afterRenameHandler( $oldWeb, $oldTopic, $oldAttachment,
+    $TWiki::PLUGINS->afterRenameHandler( $oldWeb, $oldTopic, $oldAttachment,
                                                      $newWeb, $newTopic, $newAttachment );
 }
 
@@ -377,10 +370,10 @@
     ASSERT($this->isa('TWiki::Store')) if DEBUG;
 
     if( $user &&
-          !$this->{session}->{security}->checkAccessPermission
+          !$TWiki::ACCESS->checkAccessPermission
             ( 'VIEW', $user, undef, undef, $topic, $web )) {
         throw TWiki::AccessControlException( 'VIEW', $user, $web, $topic,
-                                             $this->{session}->{security}->getReason());
+                                             $TWiki::ACCESS->getReason());
     }
 
     my $handler = $this->_getHandler( $web, $topic, $att );
@@ -456,12 +449,12 @@
         my $otext = $this->readTopicRaw( undef, $oldWeb, $oldTopic );
         # Note: undef $meta param will cause $otext to be parsed for meta
         if( $user &&
-              !$this->{session}->{security}->checkAccessPermission
+              !$TWiki::ACCESS->checkAccessPermission
                 ( 'CHANGE', $user, $otext, undef, $oldTopic, $oldWeb )) {
             throw TWiki::AccessControlException(
                 'CHANGE', $user,
                 $oldWeb, $oldTopic,
-                $this->{session}->{security}->getReason());
+                $TWiki::ACCESS->getReason());
         }
 
         my ( $nmeta, $ntext );
@@ -469,11 +462,11 @@
             ( $nmeta, $ntext ) = $this->readTopic( undef, $newWeb, $newTopic );
         }
         if( $user &&
-              !$this->{session}->{security}->checkAccessPermission
+              !$TWiki::ACCESS->checkAccessPermission
                 ( 'CHANGE', $user, $ntext, $nmeta, $newTopic, $newWeb )) {
             throw TWiki::AccessControlException(
                 'CHANGE', $user, $newWeb, $newTopic,
-                $this->{session}->{security}->getReason());
+                $TWiki::ACCESS->getReason());
         }
 
         $handler->moveTopic( $newWeb, $newTopic );
@@ -492,11 +485,11 @@
     if( $TWiki::cfg{Log}{rename} ) {
         my $old = $oldWeb.'.'.$oldTopic;
         my $new = $newWeb.'.'.$newTopic;
-        $this->{session}->writeLog( 'rename', $old, "moved to $new", $user );
+        $TWiki::SESSION->writeLog( 'rename', $old, "moved to $new", $user );
     }
 
     # alert plugins of topic move
-    $this->{session}->{plugins}->afterRenameHandler( $oldWeb, $oldTopic, '',
+    $TWiki::PLUGINS->afterRenameHandler( $oldWeb, $oldTopic, '',
                                                      $newWeb, $newTopic, '' );
 }
 
@@ -564,11 +557,11 @@
 
     # Log rename
     if( $TWiki::cfg{Log}{rename} ) {
-        $this->{session}->writeLog( 'renameweb', $oldWeb, 'moved to '.$newWeb, $user );
+        $TWiki::SESSION->writeLog( 'renameweb', $oldWeb, 'moved to '.$newWeb, $user );
     }
 
     # alert plugins of web move
-    $this->{session}->{plugins}->afterRenameHandler( $oldWeb, '', '', $newWeb, '', '' );
+    $TWiki::PLUGINS->afterRenameHandler( $oldWeb, '', '', $newWeb, '', '' );
 }
 
 =pod
@@ -592,11 +585,11 @@
     ASSERT($this->isa('TWiki::Store')) if DEBUG;
 
     if( $user &&
-          !$this->{session}->{security}->checkAccessPermission
+          !$TWiki::ACCESS->checkAccessPermission
             ( 'VIEW', $user, undef, undef, $topic, $web )) {
         throw TWiki::AccessControlException(
             'VIEW', $user, $web, $topic,
-            $this->{session}->{security}->getReason());
+            $TWiki::ACCESS->getReason());
     }
 
     my $handler = $this->_getHandler( $web, $topic, $attachment );
@@ -733,7 +726,7 @@
       $handler->getRevisionInfo( $rev );
     $rev = $rrev;
 
-    $user = $this->{session}->{users}->findUser( $user ) if $user;
+    $user = $TWiki::USERS->findUser( $user ) if $user;
 
     return ( $date, $user, $rev, $comment );
 }
@@ -849,16 +842,16 @@
     $options = {} unless defined( $options );
 
     if( $user &&
-          !$this->{session}->{security}->checkAccessPermission
+          !$TWiki::ACCESS->checkAccessPermission
             ( 'CHANGE', $user, undef, undef, $topic, $web )) {
         throw TWiki::AccessControlException(
             'CHANGE', $user, $web, $topic,
-            $this->{session}->{security}->getReason());
+            $TWiki::ACCESS->getReason());
     }
-    my $plugins = $this->{session}->{plugins};
+
     # Semantics inherited from Cairo. See
     # TWiki:Codev.BugBeforeSaveHandlerBroken
-    if( $plugins->haveHandlerFor( 'beforeSaveHandler' )) {
+    if( $TWiki::PLUGINS->haveHandlerFor( 'beforeSaveHandler' )) {
         my $before = '';
         if( $meta ) {
             # write the meta into the topic text. Nasty compatibility
@@ -866,9 +859,9 @@
             $text = _writeMeta( $meta, $text );
             $before = $meta->stringify();
         }
-        $plugins->beforeSaveHandler( $text, $topic, $web, $meta );
+        $TWiki::PLUGINS->beforeSaveHandler( $text, $topic, $web, $meta );
         # remove meta again
-        my $after = new TWiki::Meta( $this->{session}, $web, $topic);
+        my $after = new TWiki::Meta( $web, $topic);
         $this->extractMetaData( $after, \$text );
         # If there are no changes in the $meta object, take the meta
         # from the text. Nasty compatibility requirement.
@@ -885,11 +878,11 @@
 
     # Semantics inherited from Cairo. See
     # TWiki:Codev.BugBeforeSaveHandlerBroken
-    if( $plugins->haveHandlerFor( 'afterSaveHandler' )) {
+    if( $TWiki::PLUGINS->haveHandlerFor( 'afterSaveHandler' )) {
         if( $meta ) {
             $text = _writeMeta( $meta, $text );
         }
-        $plugins->afterSaveHandler( $text, $topic, $web,
+        $TWiki::PLUGINS->afterSaveHandler( $text, $topic, $web,
                                     $error?$error->{-text}:'', $meta );
     }
 
@@ -928,7 +921,6 @@
     ASSERT($user->isa('TWiki::User')) if DEBUG;
     ASSERT(defined($opts)) if DEBUG;
     my $action;
-    my $plugins = $this->{session}->{plugins};
     my $attrs;
 
     $this->lockTopic( $user, $web, $topic );
@@ -938,12 +930,12 @@
         my( $meta, $text ) = $this->readTopic( undef, $web, $topic, undef );
 
         if( $user &&
-              !$this->{session}->{security}->checkAccessPermission
+              !$TWiki::ACCESS->checkAccessPermission
                 ( 'CHANGE', $user, $text, $meta, $topic, $web )) {
 
             throw TWiki::AccessControlException(
                 'CHANGE', $user, $web, $topic,
-                $this->{session}->{security}->getReason());
+                $TWiki::ACCESS->getReason());
         }
 
         if( $opts->{file} && !$opts->{stream} ) {
@@ -967,7 +959,7 @@
 
             my $tmpFile;
 
-            if( $plugins->haveHandlerFor( 'beforeAttachmentSaveHandler' )) {
+            if( $TWiki::PLUGINS->haveHandlerFor( 'beforeAttachmentSaveHandler' )) {
                 # SMELL: legacy spec of beforeAttachmentSaveHandler requires
                 # a local copy of the stream. This could be a problem for
                 # very big data files.
@@ -987,7 +979,7 @@
                 }
                 close( $fh );
                 $attrs->{tmpFilename} = $tmpFile;
-                $plugins->beforeAttachmentSaveHandler( $attrs, $topic, $web );
+                $TWiki::PLUGINS->beforeAttachmentSaveHandler( $attrs, $topic, $web );
                 open( $opts->{stream}, "<$tmpFile" );
                 binmode( $opts->{stream} );
             }
@@ -1002,8 +994,8 @@
 
             unlink( $tmpFile ) if( $tmpFile && -e $tmpFile );
 
-            if( $plugins->haveHandlerFor( 'afterAttachmentSaveHandler' )) {
-                $plugins->afterAttachmentSaveHandler( $attrs, $topic, $web,
+            if( $TWiki::PLUGINS->haveHandlerFor( 'afterAttachmentSaveHandler' )) {
+                $TWiki::PLUGINS->afterAttachmentSaveHandler( $attrs, $topic, $web,
                                                       $error ? 
                                                         $error->{-text} : '' );
             }
@@ -1029,7 +1021,7 @@
         }
 
         if( $opts->{createlink} ) {
-            $text .= $this->{session}->{attach}->getAttachmentLink(
+            $text .= $TWiki::ATTACH->getAttachmentLink(
                 $user, $web, $topic, $attachment, $meta );
         }
 
@@ -1040,7 +1032,7 @@
     };
 
     if ( ( ! $opts->{dontlog} ) && ( $TWiki::cfg{Log}{$action} ) ) {
-        $this->{session}->writeLog( $action, $web.'.'.$topic, $attachment, $user );
+        $TWiki::SESSION->writeLog( $action, $web.'.'.$topic, $attachment, $user );
     }
 }
 
@@ -1051,7 +1043,7 @@
 
     ASSERT($user->isa('TWiki::User')) if DEBUG;
 
-    $meta ||= new TWiki::Meta( $this->{session}, $web, $topic );
+    $meta ||= new TWiki::Meta( $web, $topic );
 
     my $handler = $this->_getHandler( $web, $topic );
     my $currentRev = $handler->numRevisions() || 0;
@@ -1095,7 +1087,7 @@
         $this->_recordChange( $web, $topic, $user, $nextRev, $extra );
 
         if( ( $TWiki::cfg{Log}{save} ) && ! ( $options->{dontlog} ) ) {
-            $this->{session}->writeLog( 'save', $web.'.'.$topic,
+            $TWiki::SESSION->writeLog( 'save', $web.'.'.$topic,
                                         $extra, $user );
         }
     } finally {
@@ -1165,7 +1157,7 @@
         my $extra = "repRev $rev by " . $revuser->login() .
             ' '. TWiki::Time::formatTime( $revdate, '$rcs', 'gmtime' );
         $extra   .= ' minor' if( $options->{minor} );
-        $this->{session}->writeLog( $options->{operation} || 'save',
+        $TWiki::SESSION->writeLog( $options->{operation} || 'save',
                                     $web.'.'.$topic, $extra, $user );
     }
 }
@@ -1210,7 +1202,7 @@
     # TODO: delete entry in .changes
 
     # write log entry
-    $this->{session}->writeLog( 'cmd', $web.'.'.$topic, 'delRev by '.
+    $TWiki::SESSION->writeLog( 'cmd', $web.'.'.$topic, 'delRev by '.
                                   $user->login().": $rev", $user );
 }
 
@@ -1243,14 +1235,14 @@
     while ( 1 ) {
         my ( $user, $time ) = $handler->isLocked();
         last if ( !$user || $locker->wikiName() eq $user );
-        $this->{session}->writeWarning( "Lock on $web.$topic for ".
+        $TWiki::SESSION->writeWarning( "Lock on $web.$topic for ".
                                           $locker->wikiName().
                                             " denied by $user" );
         # see how old the lock is. If it's older than 2 minutes,
         # break it anyway. Locks are atomic, and should never be
         # held that long, by _any_ process.
         if ( time() - $time > 2 * 60 ) {
-            $this->{session}->writeWarning
+            $TWiki::SESSION->writeWarning
               ( $locker->wikiName()." broke ${user}s lock on $web.$topic" );
             $handler->setLock( 0 );
             last;
@@ -1368,27 +1360,27 @@
     # If there is no meta data then convert from old format
     if( ! $meta->count( 'TOPICINFO' ) ) {
         if ( $$rtext =~ /<!--TWikiAttachment-->/ ) {
-            $$rtext = $this->{session}->{attach}->migrateToFileAttachmentMacro( $meta,
+            $$rtext = $TWiki::ATTACH->migrateToFileAttachmentMacro( $meta,
                                                                                 $$rtext );
         }
 
         if ( $$rtext =~ /<!--TWikiCat-->/ ) {
             require TWiki::Compatibility;
-            $$rtext = TWiki::Compatibility::upgradeCategoryTable( $this->{session}, $meta->web(), $meta->topic(),
+            $$rtext = TWiki::Compatibility::upgradeCategoryTable( $TWiki::SESSION, $meta->web(), $meta->topic(),
                                                                   $meta, $$rtext );
         }
     } elsif( $format eq '1.0beta' ) {
         # This format used live at DrKW for a few months
         if( $$rtext =~ /<!--TWikiCat-->/ ) {
             require TWiki::Compatibility;
-            $$rtext = TWiki::Compatibility::upgradeCategoryTable( $this->{session}, $meta->web(), $meta->topic(),
+            $$rtext = TWiki::Compatibility::upgradeCategoryTable( $TWiki::SESSION, $meta->web(), $meta->topic(),
                                                                   $meta,
                                                                   $$rtext );
         }
-        $this->{session}->{attach}->upgradeFrom1v0beta( $meta );
+        $TWiki::ATTACH->upgradeFrom1v0beta( $meta );
         if( $meta->count( 'TOPICMOVED' ) ) {
             my $moved = $meta->get( 'TOPICMOVED' );
-            my $u = $this->{session}->{users}->findUser( $moved->{by} );
+            my $u = $TWiki::USERS->findUser( $moved->{by} );
             $moved->{by} = $u->wikiName() if $u;
             $meta->put( 'TOPICMOVED', $moved );
         }
@@ -1436,7 +1428,7 @@
     }
     close( $strm );
 
-    my $meta = new TWiki::Meta( $this->{session}, $web, $topic );
+    my $meta = new TWiki::Meta( $web, $topic );
     $this->extractMetaData( $meta, \$data );
     my $parentMeta = $meta->get( 'TOPICPARENT' );
     return $parentMeta->{name} if $parentMeta;
@@ -1576,10 +1568,10 @@
         @webList = grep { /(?:^_|\/_)/, } @webList;
     }
 
-    my $user = $this->{session}->{user};
+    my $user = $TWiki::SESSION->{user};
     if( $filter =~ /\bpublic\b/ && !$user->isAdmin()) {
-        my $prefs = $this->{session}->{prefs};
-        my $wn = $this->{session}->{webName};
+        my $prefs = $TWiki::PREFS;
+        my $wn = $TWiki::SESSION->{webName};
         @webList =
           grep {
               $_ eq $wn ||
@@ -1588,10 +1580,9 @@
     }
 
     if( $filter =~ /\ballowed\b/ ) {
-        my $security = $this->{session}->{security};
         @webList =
           grep {
-              $security->checkAccessPermission(
+              $TWiki::ACCESS->checkAccessPermission(
                   'VIEW', $user, undef, undef, undef, $_ )
           } @webList;
     }
@@ -1658,7 +1649,7 @@
 
     unless( $baseWeb ) {
         # For a web to be a web, it has to have at least one topic
-        my $meta = new TWiki::Meta( $this->{session}, $newWeb,
+        my $meta = new TWiki::Meta( $newWeb,
                                     $TWiki::cfg{WebPrefsTopicName} );
         $this->saveTopic( $user, $newWeb, $TWiki::cfg{WebPrefsTopicName},
                           "Preferences", $meta );
@@ -1908,8 +1899,8 @@
     my ( $this, $params ) = @_;
 
     my $attrType = $params->{type} || 'FIELD';
-    my $attrWeb = $params->{web} || $this->{session}->{webName};
-    my $attrTopic = $params->{topic} || $this->{session}->{topicName};
+    my $attrWeb = $params->{web} || $TWiki::SESSION->{webName};
+    my $attrTopic = $params->{topic} || $TWiki::SESSION->{topicName};
 
     my $searchVal = 'XXX';
 
@@ -1928,7 +1919,7 @@
 
     my $text = '';
     if ($params->{format}) {
-        $text = $this->{session}->{search}->searchWeb
+        $text = $TWiki::SEARCH->searchWeb
         (
          format	       => $params->{format},
          search        => $searchVal,
@@ -1943,7 +1934,7 @@
          inline        => 1,
         );
     } else {
-    $this->{session}->{search}->searchWeb
+    $TWiki::SEARCH->searchWeb
       (
        _callback     => \&_collate,
        _cbdata       => \$text,,
@@ -2054,7 +2045,7 @@
     my $handler = $this->_getHandler( $web, $topic );
     my $lease = $handler->getLease();
     if( $lease ) {
-        my $user = $this->{session}->{users}->findUser( $lease->{user} );
+        my $user = $TWiki::USERS->findUser( $lease->{user} );
         ASSERT( $user->isa('TWiki::User')) if DEBUG;
         $lease->{user} = $user;
     }
Index: TWiki/Templates.pm
===================================================================
--- TWiki/Templates.pm	(revision 13172)
+++ TWiki/Templates.pm	(working copy)
@@ -53,18 +53,15 @@
 
 =pod
 
----++ ClassMethod new ( $session )
+---++ ClassMethod new()
 
 Constructor. Creates a new template database object.
-   * $session - session (TWiki) object
 
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
-    $this->{session} = $session;
 
     $this->{VARS} = { sep => ' | ' };
 
@@ -149,7 +146,7 @@
     if( $context ) {
         $template = $then if defined( $then );
         foreach my $id ( split( /\,\s*/, $context )) {
-            unless( $this->{session}->{context}->{$id} ) {
+            unless( $TWiki::SESSION->{context}->{$id} ) {
                 $template = ( $else || '' );
                 last;
             }
@@ -269,12 +266,11 @@
 # STATIC: Return value: raw template text, or '' if read fails
 sub _readTemplateFile {
     my( $this, $name, $skins, $web ) = @_;
-    my $session = $this->{session};
-    my $store = $session->{store};
+    my $store = $TWiki::STORE;
 
-    $skins = $session->getSkin() unless defined( $skins );
+    $skins = $TWiki::SESSION->getSkin() unless defined( $skins );
     #print STDERR "SKIN path is $skins\n";
-    $web ||= $session->{webName};
+    $web ||= $TWiki::SESSION->{webName};
     $name ||= '';
 
     # SMELL: not i18n-friendly (can't have accented characters in skin name)
@@ -291,14 +287,14 @@
     my $userdirweb = $web;
     my $userdirname = $name;
     if( $name =~ /^(.+)\.(.+?)$/ ) {
-       $userdirweb = ucfirst($1);
-       $userdirname = ucfirst($2);
+        $userdirweb = ucfirst($1);
+        $userdirname = ucfirst($2);
 
-       # if the name can be parsed into $web.$name, then this is an attempt
-       # to explicit include that topic. No further searching required.
-       if( validateTopic($session,$store,$session->{user},$userdirname,$userdirweb )) {
-	   return retrieveTopic( $store, $userdirweb, $userdirname );
-       }
+        # if the name can be parsed into $web.$name, then this is an attempt
+        # to explicit include that topic. No further searching required.
+        if( _validateTopic( $userdirname, $userdirweb )) {
+            return _retrieveTopic( $userdirweb, $userdirname );
+        }
     }
     else {
         $userdirweb = ucfirst($userdirweb);
@@ -338,16 +334,16 @@
 
 	  if ( $userdir ) {
 	    # candidate in user directory
-	    my ($web1, $name1) = $session->normalizeWebTopicName($web, $file);
+	    my ($web1, $name1) = $TWiki::SESSION->normalizeWebTopicName($web, $file);
 
-	    if( validateTopic($session,$store,$session->{user},$name1,$web1) ) {
-	      next if (defined($this->{files}->{'topic'.$session->{user},$name1,$web1}));
+	    if( _validateTopic( $name1, $web1 )) {
+	      next if (defined($this->{files}->{'topic'.$TWiki::SESSION->{user},$name1,$web1}));
 	      #recursion prevention.
-	      $this->{files}->{'topic'.$session->{user},$name1,$web1} = 1;
-	      return retrieveTopic( $store, $web1, $name1 );
+	      $this->{files}->{'topic'.$TWiki::SESSION->{user},$name1,$web1} = 1;
+	      return _retrieveTopic( $web1, $name1 );
 	    }
 	  } else {
-	    if( validateFile( $file )) {
+	    if( _validateFile( $file )) {
 	      next if (defined($this->{files}->{$file}));
 	      #recursion prevention.
 	      $this->{files}->{$file} = 1;
@@ -365,21 +361,22 @@
     return '';
 }
 
-sub validateFile {
+sub _validateFile {
    my $file = shift;
    return -e $file;
 }
 
-sub validateTopic {
-   my( $session, $store, $user, $topic, $web ) = @_;
-   return $store->topicExists( $web, $topic ) && 
-   $session->{security}->checkAccessPermission(
-       'VIEW', $user, undef, undef, $topic, $web );
+sub _validateTopic {
+   my( $topic, $web ) = @_;
+   return $TWiki::STORE->topicExists( $web, $topic ) && 
+   $TWiki::ACCESS->checkAccessPermission(
+       'VIEW', $TWiki::SESSION->{user}, undef, undef, $topic, $web );
 }
 
-sub retrieveTopic {
-   my( $store, $web, $topic ) = @_;
-   my ( $meta, $text ) = $store->readTopic( undef, $web, $topic, undef );
+sub _retrieveTopic {
+   my( $web, $topic ) = @_;
+   my ( $meta, $text ) = $TWiki::STORE->readTopic(
+       undef, $web, $topic, undef );
    return $text;
 }
 
Index: TWiki/Sandbox.pm
===================================================================
--- TWiki/Sandbox.pm	(revision 13172)
+++ TWiki/Sandbox.pm	(working copy)
@@ -41,7 +41,7 @@
 
 =pod
 
----++ ClassMethod new( $os, $realOS )
+---++ ClassMethod new()
 
 Construct a new sandbox suitable for $os, setting
 flags for platform features that help.  $realOS distinguishes
@@ -50,16 +50,13 @@
 =cut
 
 sub new {
-    my ( $class, $os, $realOS ) = @_;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
+    my ($os, $realOS) = ($TWiki::cfg{OS}, $TWiki::cfg{DetailedOS});
 
-    ASSERT( defined $os ) if DEBUG;
-    ASSERT( defined $realOS ) if DEBUG;
-
     $this->{REAL_SAFE_PIPE_OPEN} = 1;     # supports open(FH, '-|")
     $this->{EMULATED_SAFE_PIPE_OPEN} = 1; # supports pipe() and fork()
 
-
     # filter the support based on what platforms are proven
     # not to work.
     #from the Activestate Docco this is _only_ defined on ActiveState Perl
Index: TWiki/If.pm
===================================================================
--- TWiki/If.pm	(revision 13172)
+++ TWiki/If.pm	(working copy)
@@ -58,12 +58,12 @@
 =cut
 
 sub evaluate {
-    my( $this, $session ) = @_;
+    my( $this ) = @_;
 
     return $this->{op} unless ref( $this->{op} );
 
     my $fn = $this->{op}->{exec};
-    return &$fn( $session, $this->{left}, $this->{right} );
+    return &$fn( $TWiki::SESSION, $this->{left}, $this->{right} );
 }
 
 sub stringify {
@@ -129,7 +129,7 @@
         my $eval =  $b->evaluate($twiki);
         return 0 unless $eval;
         return 1 if( defined( $twiki->{cgiQuery}->param( $eval )));
-        return 1 if( defined( $twiki->{prefs}->getPreferencesValue( $eval )));
+        return 1 if( defined( $TWiki::PREFS->getPreferencesValue( $eval )));
         return 1 if( defined( $twiki->{SESSION_TAGS}{$eval} ));
         return 0;
     }
